    PROGRAM nag_mat_norm_ex05

      ! Example Program Text for nag_mat_norm
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_in, nag_std_out
      USE nag_mat_norm, ONLY : nag_hessen_mat_norm
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Intrinsic Functions ..
      INTRINSIC KIND, MAX
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)
      ! .. Local Scalars ..
      INTEGER :: i, n
      ! .. Local Arrays ..
      COMPLEX (wp), ALLOCATABLE :: a(:,:)
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_mat_norm_ex05'

      READ (nag_std_in,*)          ! Skip heading in data file
      READ (nag_std_in,*) n

      ALLOCATE (a(n,n))            ! Allocate storage

      DO i = 1, n
        READ (nag_std_in,*) a(i,MAX(1,i-1):)
      END DO

      WRITE (nag_std_out,*)
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'One-norm of (A) =', &
       nag_hessen_mat_norm(a)
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Infinity Norm of (A) =', &
       nag_hessen_mat_norm(a,norm='i')
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Frobenius Norm of (A) =', &
       nag_hessen_mat_norm(a,norm='f')
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'MAX(ABS(A(i,j))) =', &
       nag_hessen_mat_norm(a,norm='m')

      DEALLOCATE (a)               ! Deallocate storage

    END PROGRAM nag_mat_norm_ex05
